#ifndef CUBE_HPP_INCLUDED
#define CUBE_HPP_INCLUDED

class Cube
{
    private :
        float X , Y , Z , Largeur , Hauteur , Profondeur ;
        int Rouge , Vert , Bleu ;

    public :
        Cube ( float L , float H , float P , int R , int V , int B ) ;

        void Afficher ( ) ;

        float GetPosX ( ) { return X ; } ;
        float GetPosY ( ) { return Y ; } ;
        float GetPosZ ( ) { return Z ; } ;

        void SetPos ( float Xn , float Yn , float Zn ) { X = Xn - ( Largeur / 2 ) ; Y = Yn - ( Hauteur / 2 ) ; Z = Zn - ( Profondeur / 2 ) ; } ;
        void SetPosX ( float Xn ) { X = Xn - ( Largeur / 2 ) ; } ;
        void SetPosY ( float Yn ) { Y = Yn - ( Hauteur / 2 ) ; } ;
        void SetPosZ ( float Zn ) { Z = Zn - ( Profondeur / 2 ) ; } ;
} ;

Cube :: Cube ( float L , float H , float P , int R , int V , int B )
{
    X = L / ( - 2 ) ;
    Y = H / ( - 2 ) ;
    Z = P / ( - 2 ) ;
    Largeur = L ;
    Hauteur = H ;
    Profondeur = P ;
    Rouge = R ;
    Vert = V ;
    Bleu = B ;
}

void Cube :: Afficher ( )
{
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL ) ;
    // Face avant
    glBegin ( GL_QUADS ) ;
        glColor3ub ( Rouge , Vert , Bleu ) ;
        glVertex3d ( X , Y , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z + Profondeur ) ;
        glVertex3d ( X , Y + Hauteur , Z + Profondeur ) ;
    glEnd ( ) ;
    // Face gauche
    glBegin ( GL_QUADS ) ;
        glVertex3d ( X , Y , Z + Profondeur ) ;
        glVertex3d ( X , Y , Z ) ;
        glVertex3d ( X , Y + Hauteur , Z ) ;
        glVertex3d ( X , Y + Hauteur , Z + Profondeur ) ;
    glEnd ( ) ;
    // Face droite
    glBegin ( GL_QUADS ) ;
        glVertex3d ( X + Largeur , Y , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y , Z ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z + Profondeur ) ;
    glEnd ( ) ;
    // Face arrire
    glBegin ( GL_QUADS ) ;
        glVertex3d ( X , Y , Z ) ;
        glVertex3d ( X + Largeur , Y , Z ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z ) ;
        glVertex3d ( X , Y + Hauteur , Z ) ;
    glEnd ( ) ;
    // Face du dessus
    glBegin ( GL_QUADS ) ;
        glVertex3d ( X , Y + Hauteur , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y + Hauteur , Z ) ;
        glVertex3d ( X , Y + Hauteur , Z ) ;
    glEnd ( ) ;
    // Face du dessous
    glBegin ( GL_QUADS ) ;
        glVertex3d ( X , Y , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y , Z + Profondeur ) ;
        glVertex3d ( X + Largeur , Y , Z ) ;
        glVertex3d ( X , Y , Z ) ;
    glEnd ( ) ;
}

#endif // CUBE_HPP_INCLUDED
