#ifndef MATRICE_H_INCLUDED
#define MATRICE_H_INCLUDED

class Matrice
{
    private :
        int Largeur , Profondeur , TailleLargeur , TailleProfondeur ;
        int X , Y , Z ;
        int** Hauteur ;
        GLuint Texture ;

    public :
        Matrice ( int L , int P , int TL , int TP , const char * NomDuFichier , int LT , int HT ) ;

        void Afficher ( ) ;
        void Aleatoire ( int Min , int Max ) ;

        void SetHauteur ( int X , int Z , int H ) ;
        void SetPosition ( int I , int J , int K ) ;
} ;

Matrice :: Matrice ( int L , int P , int TL , int TP , const char * NomDuFichier , int LT , int HT )
{
    int I , J ;

    Largeur = L ;
    Profondeur = P ;
    TailleLargeur = TL ;
    TailleProfondeur = TP ;

    X = 0 ;
    Y = 0 ;
    Z = 0 ;

    // Initialisation de la matrice des profondeurs
    Hauteur = new int * [ L + 1 ] ;
    for ( I = 0 ; I < L + 1 ; I ++ )
    {
        Hauteur [ I ] = new int [ P + 1 ] ;
    }

    for ( J = 0 ; J < P + 1 ; J ++ )
    {
        for ( I = 0 ; I < L + 1 ; I ++ )
        {
            Hauteur [ I ] [ J ] = 0 ;
        }
    }

    // Rcupration de la texture
    BYTE * data ;
    FILE * file ;

    file = fopen ( NomDuFichier , "rb" ) ;

    data = new BYTE ( LT * HT * 3 ) ;
    //exit(LT*HT*3);
    fread ( data , LT * HT * 3 , 1 , file ) ;
    fclose ( file ) ;

    glGenTextures ( 1 , &Texture ) ;
    glBindTexture ( GL_TEXTURE_2D , Texture ) ;
    glTexEnvf ( GL_TEXTURE_ENV , GL_TEXTURE_ENV_MODE , GL_MODULATE ) ;
    glTexParameterf ( GL_TEXTURE_2D , GL_TEXTURE_MIN_FILTER , GL_LINEAR_MIPMAP_NEAREST ) ;
    glTexParameterf ( GL_TEXTURE_2D , GL_TEXTURE_MAG_FILTER , GL_LINEAR ) ;

    gluBuild2DMipmaps ( GL_TEXTURE_2D , 3 , LT , HT , GL_RGB , GL_UNSIGNED_BYTE , data ) ;
    delete [ ] data ;
}


void Matrice :: Afficher ( )
{
    int I , J ;

    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE) ;
//    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL) ;

    for ( J = 0 ; J < Profondeur ; J ++)
    {
        for ( I = 0 ; I < Largeur ; I ++ )
        {
            glBindTexture ( GL_TEXTURE_2D , Texture ) ;
            glBegin ( GL_QUADS ) ;
                glColor3ub ( 255 , 255 , 255 ) ;
                glTexCoord2d ( 0 , 0 ) ;
                glVertex3d ( ( I * TailleLargeur ) + X , Hauteur [ I ] [ J ] + Y , ( J * TailleProfondeur ) + Z ) ;
                glTexCoord2d ( 0 , 1 ) ;
                glVertex3d ( ( ( I + 1 ) * TailleLargeur ) + X , Hauteur [ I + 1 ] [ J ] + Y , ( J * TailleProfondeur ) + Z ) ;
                glTexCoord2d ( 1 , 1 ) ;
                glVertex3d ( ( ( I + 1 ) * TailleLargeur ) + X , Hauteur [ I + 1 ] [ J + 1 ] + Y , ( ( J + 1 ) * TailleProfondeur ) + Z ) ;
                glTexCoord2d ( 1 , 0 ) ;
                glVertex3d ( ( I * TailleLargeur ) + X , Hauteur [ I ] [ J + 1 ] + Y , ( ( J + 1 ) * TailleProfondeur ) + Z ) ;
            glEnd ( ) ;
        }
    }
}

void Matrice :: SetHauteur ( int X , int Z , int H )
{
    Hauteur [ X ] [ Z ] = H ;
}

void Matrice :: Aleatoire ( int Min , int Max )
{
    int I , J ;

    for ( J = 0 ; J < Profondeur + 1 ; J ++ )
    {
        for ( I = 0 ; I < Largeur + 1 ; I ++ )
        {
            Hauteur [ I ] [ J ] = Min + ( rand ( ) % ( Max - Min ) ) ;
        }
    }
}

void Matrice :: SetPosition ( int I , int J , int K )
{
    X = I ;
    Y = J ;
    Z = K ;
}

#endif // MATRICE_HPP_INCLUDED
